#La fonction et les donnes utilises sont ranges dans le repertoire suivant
CalibrageFonctionsR="C:\\Documents and Settings\\akamega\\Mes documents\\1389 - Livre\\Calibrage\\Calibrage R Fonctions"
CalibrageDonnees="C:\\Documents and Settings\\akamega\\Mes documents\\1389 - Livre\\Calibrage\\Calibrage Donnees"

#Chargement des packages utiliss
require(tseries)
require(lmtest)

#Chargement de la fonction
source(paste(CalibrageFonctionsR,"\\F_ArchLmTest.r",sep=""))
  
#Chargement des donnes
setwd(CalibrageDonnees)
Rdt_Immobilier<-scan("Rdt_Immobilier.txt")

#Dfinition du nombre d'observation dans le fichier en entre
Nobs<-length(Rdt_Immobilier)
#Dfinition des sries
Rdt_Immobilier_tplusun=Rdt_Immobilier[2:Nobs]
Rdt_Immobilier_t=Rdt_Immobilier[1:(Nobs-1)]
  
#Rgression par les MCO
reg_Rdt_Immobilier=lm(Rdt_Immobilier_tplusun~Rdt_Immobilier_t)
  
#Prsentation des rsultats des MCO
summary(reg_Rdt_Immobilier)
  
#Moyenne des rsidus
mean(residuals(reg_Rdt_Immobilier))
#Tests statistiques
jarque.bera.test(residuals(reg_Rdt_Immobilier))
bgtest(reg_Rdt_Immobilier)
archlmtest(residuals(reg_Rdt_Immobilier),1,) # appel de la fonction pour le test ARCH(1)
  
#Calcul des paramtres du modle sur l'immobilier d'Ahlgrim
VRM_Rdt_Immobilier=-log(coef(reg_Rdt_Immobilier)[2])
names(VRM_Rdt_Immobilier)="VRM_Rdt_Immobilier"
Moy_Rdt_Immobilier=coef(reg_Rdt_Immobilier)[1]/(1-coef(reg_Rdt_Immobilier)[2])
names(Moy_Rdt_Immobilier)="Moy_Rdt_Immobilier"
Sigma_Rdt_Immobilier=sd(resid(reg_Rdt_Immobilier))*sqrt((Nobs-2)/(Nobs-3))/sqrt((1-exp(-2*VRM_Rdt_Immobilier))/(2*VRM_Rdt_Immobilier))
names(Sigma_Rdt_Immobilier)="Sigma_Rdt_Immobilier"
