#La fonction et les donnes utilises sont ranges dans le repertoire suivant
CalibrageFonctionsR="C:\\Documents and Settings\\akamega\\Mes documents\\1389 - Livre\\Calibrage\\Calibrage R Fonctions"
CalibrageDonnees="C:\\Documents and Settings\\akamega\\Mes documents\\1389 - Livre\\Calibrage\\Calibrage Donnees"

#Chargement des packages utiliss
require(tseries)
require(lmtest)

#Chargement de la fonction
source(paste(CalibrageFonctionsR,"\\F_ArchLmTest.r",sep=""))
  
#Chargement des donnes
setwd(CalibrageDonnees)
Tx_Inflation<-scan("Tx_Inflation.txt")

#Dfinition du nombre d'observation dans le fichier en entre
Nobs<-length(Tx_Inflation)
#Dfinition des sries
Tx_Inflation_tplusun=Tx_Inflation[2:Nobs]
Tx_Inflation_t=Tx_Inflation[1:(Nobs-1)]
  
#Rgression par les MCO
reg_Tx_Inflation=lm(Tx_Inflation_tplusun~Tx_Inflation_t)
  
#Prsentation des rsultats des MCO
summary(reg_Tx_Inflation)
  
#Moyenne des rsidus
mean(residuals(reg_Tx_Inflation))
#Tests statistiques
jarque.bera.test(residuals(reg_Tx_Inflation))
bgtest(reg_Tx_Inflation)
archlmtest(residuals(reg_Tx_Inflation),1,) # appel de la fonction pour le test ARCH(1)
  
#Calcul des paramtres du modle d'inflation d'Ahlgrim
VRM_Tx_Inflation=-log(coef(reg_Tx_Inflation)[2])
names(VRM_Tx_Inflation)="VRM_Tx_Inflation"
Moy_Tx_Inflation=coef(reg_Tx_Inflation)[1]/(1-coef(reg_Tx_Inflation)[2])
names(Moy_Tx_Inflation)="Moy_Tx_Inflation"
Sigma_Tx_Inflation=sd(resid(reg_Tx_Inflation))*sqrt((Nobs-2)/(Nobs-3))/sqrt((1-exp(-2*VRM_Tx_Inflation))/(2*VRM_Tx_Inflation))
names(Sigma_Tx_Inflation)="Sigma_Tx_Inflation"