#La fonction et les donnes utilises sont ranges dans le repertoire suivant
CalibrageFonctionsR="C:\\Documents and Settings\\akamega\\Mes documents\\1389 - Livre\\Calibrage\\Calibrage R Fonctions"
CalibrageDonnees="C:\\Documents and Settings\\akamega\\Mes documents\\1389 - Livre\\Calibrage\\Calibrage Donnees"

#Chargement des packages utiliss
require(tseries)
require(lmtest)

#Chargement de la fonction
source(paste(CalibrageFonctionsR,"\\F_ArchLmTest.r",sep=""))
  
#Chargement des donnes
setwd(CalibrageDonnees)
Tx_reel_long<-scan("Tx_reel_long.txt")
Tx_reel_court<-scan("Tx_reel_court.txt")

#Dfinition du nombre d'observation dans le fichier en entre
Nobs<-length(Tx_reel_long)
#Dfinition des sries
Tx_reel_long_tplusun=Tx_reel_long[2:Nobs]
Tx_reel_long_t=Tx_reel_long[1:(Nobs-1)]
Tx_reel_court_t=Tx_reel_court[1:(Nobs-1)]
Tx_reel_court_tplusun=Tx_reel_court[2:Nobs]
  
#Rgression par les MCO
reg_Tx_reel_long=lm(Tx_reel_long_tplusun~Tx_reel_long_t)
  
#Prsentation des rsultats des MCO
summary(reg_Tx_reel_long)
  
#Moyenne des rsidus
mean(residuals(reg_Tx_reel_long))
#Tests statistiques
jarque.bera.test(residuals(reg_Tx_reel_long))
bgtest(reg_Tx_reel_long)
archlmtest(residuals(reg_Tx_reel_long),1,) # appel de la fonction pour le test ARCH(1)
  
#Calcul des paramtres du modle des taux  long terme d'Ahlgrim
VRM_Tx_reel_long=-log(coef(reg_Tx_reel_long)[2])
names(VRM_Tx_reel_long)="VRM_Tx_reel_long"
Moy_Tx_reel_long=coef(reg_Tx_reel_long)[1]/(1-coef(reg_Tx_reel_long)[2])
names(Moy_Tx_reel_long)="Moy_Tx_reel_long"
Sigma_Tx_reel_long=sd(resid(reg_Tx_reel_long))*sqrt((Nobs-2)/(Nobs-3))/sqrt((1-exp(-2*VRM_Tx_reel_long))/(2*VRM_Tx_reel_long))
names(Sigma_Tx_reel_long)="Sigma_Tx_reel_long"

#Calcul de la diffrence entre les taux de LT estims et les taux de CT observs et ajustement de la taille du vecteur
Chap_Tx_reel_long_tplusun=coef(reg_Tx_reel_long)[1]+coef(reg_Tx_reel_long)[2]*Tx_reel_long_t
Diff_ChapLT_CT=Chap_Tx_reel_long_tplusun-Tx_reel_court_tplusun
Diff_ChapLT_CT=Diff_ChapLT_CT[1:(Nobs-2)]
#Calcul de la diffrence entre les taux de CT observs en t+1 et ceux observs en t
Diff_CT=Tx_reel_court_tplusun-Tx_reel_court_t
Diff_CT=Diff_CT[2:(Nobs-1)]

#Rgression par les MCO
reg_DiffTx_reel_court=lm(Diff_CT~Diff_ChapLT_CT-1)
  
#Prsentation des rsultats des MCO
summary(reg_DiffTx_reel_court)
  
#Moyenne des rsidus
mean(residuals(reg_DiffTx_reel_court))
#Tests statistiques
jarque.bera.test(residuals(reg_DiffTx_reel_court))
bgtest(reg_DiffTx_reel_court)
archlmtest(residuals(reg_DiffTx_reel_court),1,) # appel de la fonction pour le test ARCH(1)
  
#Calcul des paramtres du modle des taux  court terme d'Ahlgrim
VRM_Tx_reel_court=-log(1-coef(reg_DiffTx_reel_court)[1])
names(VRM_Tx_reel_court)="VRM_Tx_reel_court"
Sigma_Tx_reel_court=sd(resid(reg_DiffTx_reel_court))*sqrt(((Nobs-1)-2)/((Nobs-1)-3))/sqrt((1-exp(-2*VRM_Tx_reel_court))/(2*VRM_Tx_reel_court))
names(Sigma_Tx_reel_court)="Sigma_Tx_reel_court"
