#La fonction et les donnes utilises sont ranges dans le repertoire suivant
CalibrageFonctionsR="C:\\Documents and Settings\\akamega\\Mes documents\\1389 - Livre\\Calibrage\\Calibrage R Fonctions"
CalibrageDonnees="C:\\Documents and Settings\\akamega\\Mes documents\\1389 - Livre\\Calibrage\\Calibrage Donnees"

#Chargement des packages utiliss
require(tseries)
require(lmtest)

#Chargement de la fonction
source(paste(CalibrageFonctionsR,"\\F_ArchLmTest.r",sep=""))

#Chargement des donnes
setwd(CalibrageDonnees)
Tx_Inflation<-scan("Tx_Inflation.txt")
Tx_reel_court<-scan("Tx_reel_court.txt")
Rdt_actions<-scan("Rdt_actions.txt")

#Dfinition du nombre d'observation dans le fichier en entre
Nobs<-length(Tx_Inflation)
#Dfinition des sries
Tx_Inflation_tplusun=Tx_Inflation[2:Nobs]
Tx_Inflation_t=Tx_Inflation[1:(Nobs-1)]
Tx_reel_court_tplusun=Tx_reel_court[2:Nobs]
Tx_reel_court_t=Tx_reel_court[1:(Nobs-1)]

#Rgression par les MCO
reg_Tx_Inflation=lm(Tx_Inflation_tplusun~Tx_Inflation_t)
reg_Tx_reel_court=lm(Tx_reel_court_tplusun~Tx_reel_court_t)

#Rcupration des rsidus
resid_inflation=residuals(reg_Tx_Inflation)/(sd(resid(reg_Tx_Inflation))*sqrt((Nobs-2)/(Nobs-3)))
resid_TC=residuals(reg_Tx_reel_court)/(sd(resid(reg_Tx_reel_court))*sqrt((Nobs-2)/(Nobs-3)))
resid_actions=(Rdt_actions-(mean(Rdt_actions)-(sd(Rdt_actions)^2)/2))/(sd(Rdt_actions)*sqrt(((Nobs+1)-2)/((Nobs+1)-3)))
resid_actions=resid_actions[2:(Nobs)]
resid_IPC=(Tx_Inflation-(mean(Tx_Inflation)-(sd(Tx_Inflation)^2)/2))/(sd(Tx_Inflation)*sqrt(((Nobs+1)-2)/((Nobs+1)-3)))
resid_IPC=resid_IPC[2:(Nobs)]

#Rangement des rsidus dans un tableau
tableau_resid=data.frame(resid_actions,resid_TC,resid_inflation,resid_IPC)

#Calcul de la matrice de corrlation
cor(tableau_resid)

#Rgression du produit volatilit*rsidus par les MCO
volresid_IPC=(Tx_Inflation-(mean(Tx_Inflation)-(sd(Tx_Inflation)^2)/2))
volresid_IPC=volresid_IPC[2:(Nobs)]
reg_volresid_IPC=lm(volresid_IPC~resid_actions+resid_TC+resid_inflation-1)
summary(reg_volresid_IPC)

#Moyenne des rsidus
mean(residuals(reg_volresid_IPC))
#Tests statistiques
jarque.bera.test(residuals(reg_volresid_IPC))
bgtest(reg_volresid_IPC)
archlmtest(residuals(reg_volresid_IPC),1,) # appel de la fonction pour le test ARCH(1)
