#La fonction et les donnes utilises sont ranges dans le repertoire suivant
CalibrageFonctionsR="C:\\Documents and Settings\\akamega\\Mes documents\\1389 - Livre\\Calibrage\\Calibrage R Fonctions"
CalibrageDonnees="C:\\Documents and Settings\\akamega\\Mes documents\\1389 - Livre\\Calibrage\\Calibrage Donnees"

#Chargement des packages utiliss
require(tseries)
require(lmtest)

#Chargement de la fonction
source(paste(CalibrageFonctionsR,"\\F_ArchLmTest.r",sep=""))
  
#Chargement des donnes
setwd(CalibrageDonnees)
Tx_reel_court<-scan("Tx_reel_court.txt")

#Dfinition du nombre d'observation dans le fichier en entre
Nobs<-length(Tx_reel_court)
#Dfinition des sries
Tx_reel_court_tplusun=Tx_reel_court[2:Nobs]
Tx_reel_court_t=Tx_reel_court[1:(Nobs-1)]
  
#Rgression par les MCO
reg_Tx_reel_court=lm(Tx_reel_court_tplusun~Tx_reel_court_t)
  
#Prsentation des rsultats des MCO
summary(reg_Tx_reel_court)
  
#Moyenne des rsidus
mean(residuals(reg_Tx_reel_court))
#Tests statistiques
jarque.bera.test(residuals(reg_Tx_reel_court))
bgtest(reg_Tx_reel_court)
archlmtest(residuals(reg_Tx_reel_court),1,) # appel de la fonction pour le test ARCH(1)
  
#Calcul des paramtres du modle sur l'immobilier d'Ahlgrim
VRM_Tx_reel_court=-log(coef(reg_Tx_reel_court)[2])
names(VRM_Tx_reel_court)="VRM_Tx_reel_court"
Moy_Tx_reel_court=coef(reg_Tx_reel_court)[1]/(1-coef(reg_Tx_reel_court)[2])
names(Moy_Tx_reel_court)="Moy_Tx_reel_court"
Sigma_Tx_reel_court=sd(resid(reg_Tx_reel_court))*sqrt((Nobs-2)/(Nobs-3))/sqrt((1-exp(-2*VRM_Tx_reel_court))/(2*VRM_Tx_reel_court))
names(Sigma_Tx_reel_court)="Sigma_Tx_reel_court"
