# La fonction suivante ralise le test de ARCH sur "lags" retards  partir des rsidus "x" d'une rgression par les moindres carrs
# lags : retard
# x : rsidus du modle test

archlmtest <- function (x, lags, demean = FALSE)
{
  x <- as.vector(x)
  if(demean) x <- scale(x, center = TRUE, scale = FALSE)
    lags <- lags + 1
    mat <- embed(x^2, lags)
    arch.lm <- summary(lm(mat[, 1] ~ mat[, -1]))
    STATISTIC <- arch.lm$r.squared * length(resid(arch.lm))
    names(STATISTIC) <- "Chi-squared"
    PARAMETER <- lags - 1
    names(PARAMETER) <- "df"
    PVAL <- 1 - pchisq(STATISTIC, df = PARAMETER)
    METHOD <- "ARCH LM-test"
    result <- list(statistic = STATISTIC, parameter = PARAMETER,
        p.value = PVAL, method = METHOD)
    class(result) <- "htest"
    return(result)
}
